HDU - 1010 Tempter of the Bone dfs+剪枝

3 篇文章 0 订阅

Tempter of the Bone

Description

The doggie found a bone in an ancient maze, which fascinated him a lot. However, when he picked it up, the maze began to shake, and the doggie could feel the ground sinking. He realized that the bone was a trap, and he tried desperately to get out of this maze.

The maze was a rectangle with sizes N by M. There was a door in the maze. At the beginning, the door was closed and it would open at the T-th second for a short period of time (less than 1 second). Therefore the doggie had to arrive at the door on exactly the T-th second. In every second, he could move one block to one of the upper, lower, left and right neighboring blocks. Once he entered a block, the ground of this block would start to sink and disappear in the next second. He could not stay at one block for more than one second, nor could he move into a visited block. Can the poor doggie survive? Please help him.

Input

The input consists of multiple test cases. The first line of each test case contains three integers N, M, and T (1 < N, M < 7; 0 < T < 50), which denote the sizes of the maze and the time at which the door will open, respectively. The next N lines give the maze layout, with each line containing M characters. A character is one of the following:

‘X’: a block of wall, which the doggie cannot enter;
‘S’: the start point of the doggie;
‘D’: the Door; or
‘.’: an empty block.

The input is terminated with three 0’s. This test case is not to be processed.

Output

For each test case, print in one line “YES” if the doggie can survive, or “NO” otherwise.

Sample Input

4 4 5
S.X.
..X.
..XD
….
3 4 5
S.X.
..X.
…D
0 0 0

Sample Output

NO
YES

题意:给你一张n*m的地图,’X’是墙,’.’是空地,从’S’出发,每一秒走一格,不能重复经过格子,问是否能在t时刻刚好到达’D’这个位置。

题解:
由于是刚好t时刻,所以不能用bfs(找出最短时间),而选择dfs。
朴素的dfs肯定会T掉,考虑剪枝。

有3种剪枝。
1.统计图中墙的数量,如果n*m-cnt<=t,则不能到达。这个很好理解,你把每一个非墙的部分都走过了,最多走n*m-cnt-1步,但时间还是小于t,肯定不行。
2.当剩下的步数(曼哈顿距离)大于剩下的时间的时候,也不行。

3.这道题新学到的东西,叫奇偶剪枝
对于一个矩形区域,我们可以把它二分图染色【…】,相邻的格子染不同颜色,将这个矩形分成奇数格和偶数格。
eg:
0 1 0 1 0
1 0 1 0 1
可以证明起点和终点奇偶性不同的时候(即上面的图编号不一样的时候),需要走奇数步,而奇偶性相同的时候需要走偶数步。所以我们可以判断剩下的步数的奇偶性和需要的步数的奇偶性是否相同来判断是否合法。

#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;

const int N = 10;

int dx[4]={0,0,1,-1},dy[4]={1,-1,0,0};

int n,m,t;
int sx,sy,ex,ey;
char s[N][N];
bool flag=false,vis[N][N];

void dfs(int x,int y,int d){
    if(abs(ex-x)+abs(ey-y)>t-d) return ;
    if(((x+y&1)+(ex+ey&1)&1)!=(t-d&1)) return ;
    if(d==t){
        if(s[x][y]=='D') flag=true;
        return ;
    }
    for(int i=0;i<4;++i){
        int xx=x+dx[i],yy=y+dy[i];  
        if(s[xx][yy]!='X'&&xx>=0&&xx<n&&yy>=0&&yy<m&&(!vis[xx][yy])){
            vis[xx][yy]=true;

            dfs(xx,yy,d+1);
            if(flag==true) return ;
            vis[xx][yy]=false;
        }
    }
}

int cnt=0;
void update(){
    memset(vis,0,sizeof(vis));
    flag=false;cnt=0;
}

int main(){
    while(1){
        scanf("%d%d%d",&n,&m,&t);
        if(n+m+t==0) break;
        int sx,sy;update();
        for(int i=0;i<n;++i){
            scanf("%s",s[i]);
            for(int j=0;j<m;++j){
                if(s[i][j]=='S') sx=i,sy=j;
                if(s[i][j]=='D') ex=i,ey=j;
                if(s[i][j]=='X') ++cnt;
            }
        }
        if(n*m-cnt<=t) {
            printf("NO\n");
            continue;
        }
        vis[sx][sy]=true;
        dfs(sx,sy,0);
        if(flag==true) printf("YES\n");
        else printf("NO\n");
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值